/********************************** (C) COPYRIGHT *******************************
* File Name          : Main.c
* Author             : WCH
* Version            : V1.1
* Date               : 2020/12/23
* Description 		 : 
*******************************************************************************/
#include "CH56x_common.h"
#include "CH56x_usb20.h"

/* Global define */
#define UART1_BAUD  921600

/* Global Variable */



/* Function declaration */



/*******************************************************************************
* Function Name  : DebugInit
* Description    : Initializes the UART1 peripheral.
* Input          : baudrate: UART1 communication baud rate.
* Return         : None
*******************************************************************************/
void DebugInit(UINT32 baudrate)
{
	UINT32 x;
	UINT32 t = FREQ_SYS;
	x = 10 * t * 2 / 16 / baudrate;
	x = ( x + 5 ) / 10;
	R8_UART1_DIV = 1;
	R16_UART1_DL = x;
	R8_UART1_FCR = RB_FCR_FIFO_TRIG | RB_FCR_TX_FIFO_CLR | RB_FCR_RX_FIFO_CLR | RB_FCR_FIFO_EN;
	R8_UART1_LCR = RB_LCR_WORD_SZ;
	R8_UART1_IER = RB_IER_TXD_EN;
	R32_PA_SMT |= (1<<8) |(1<<7);
	R32_PA_DIR |= (1<<8);
}

/* ͨѯ˱־λжǷתû */
extern BOOL iap_end;
/*******************************************************************************
* Function Name  : main
* Description    : Main program.
* Input          : None
* Return         : None
*******************************************************************************/
int main()
{
    UINT32 i = 0,j ;
    UINT8 val = 1;

    SystemInit(FREQ_SYS);
	Delay_Init(FREQ_SYS);

    /* ôڵ */;
	DebugInit(UART1_BAUD);
	/* IAPҪ */
	PRINT("IAP! @ %d\n", FREQ_SYS );

	/* ûɺ󣬽 R8_GLOB_RESET_KEEP Ĵд0xAA˴ѯüĴΪǷɱ̵ı־ֶ, κλɱĴ洢λþ */
	/* ûתһ */
	if( R8_GLOB_RESET_KEEP == 0xAA )
	{
        PRINT("Jump To User Code!\n");
        mDelaymS(100);
        /* ע⣺ڴ֮ǰκ裬ڴ˴رգת֮󣬸Խڿ״̬ʱ³ʼرո裬ܵһЩ */
        asm("li t0, 0x1000");
        asm("jr t0");
	}

	PRINT("Waiting UpDate....\n");
	USB20_Device_Init(ENABLE);
	PFIC_EnableIRQ(USBHS_IRQn);
	FLASH_ROMA_LOCK(0);

    while(1)
    {
        CH55X_IAPDownload( );
    }
}
